%% Plots of moments along plates radius of aluminium alloy
%% Ji Vensk
%% 2019
clc
clear all
%% Constants of the system
miu = 0.33;
E = 7e4; %% in MPa
F = 170; %% in N
r= linspace (1.25,4,1000);
r_1 = 1.25;
r_2 = 4; %% in mm
h = 0.5; %% in mm
B = (E*h^3)/(12*(1-miu^2));
%% Moments
m_rfxdforce = (F*(miu-1))/(8*pi)-((1+miu)*F*log(r))/(4*pi)-((F)/(B*4*pi)-(F*log(r_2))/(2*pi*B))*((1+miu)*B)/2;
m_tfxdforce = (F*(1-miu))/(8*pi)-((1+miu)*F*log(r))/(4*pi)-((F)/(B*4*pi)-(F*log(r_2))/(2*pi*B))*((1+miu)*B)/2;

m_rpinforce = (F*(miu-1))/(8*pi)-((1+miu)*F*log(r))/(4*pi)-(((miu-1)*F)/((1+miu)*B*4*pi)-(F*log(r_2))/(2*pi*B))*((1+miu)*B)/2;
m_tpinforce = (F*(1-miu))/(8*pi)-((1+miu)*F*log(r))/(4*pi)-(((miu-1)*F)/((1+miu)*B*4*pi)-(F*log(r_2))/(2*pi*B))*((1+miu)*B)/2;
%% Plot settings
subplot(2,2,1);  
plot(r,m_rfxdforce,'b');
title('Radial moment for fixed support')
xlabel('Radius')
ylabel('Moment')
subplot (2,2,2);
plot (r,m_tfxdforce,'r');
title('Tangential moment for fixed support')
xlabel('Radius')
ylabel('Moment')
subplot(2,2,3);  
plot(r,m_rpinforce,'b');
title('Radial moment for pinned support')
xlabel('Radius')
ylabel('Moment')
subplot (2,2,4);
plot (r,m_tpinforce,'r');
title('Tangential moment for pinned support')
xlabel('Radius')
ylabel('Moment')
suptitle('Lone force');