%% Stress calculations for general input
%% Ji Vensk
%% 2019
clc
clear all
prompt = 'enter poissons ratio of your material  ';
miu = input(prompt);
prompt2 = 'enter Youngs modulus of your material in MPa  ';
E = input(prompt2);
prompt3 = 'enter plates thickness in milimeters  ';
h = input(prompt3);
prompt4 = 'enter plates radius in milimeters  ';
r_2 = input(prompt4);
prompt5 = 'enter yield force from your SP test in Newtons  ';
F = input(prompt5);
prompt6 = 'enter ultimate tensile force from your SP test in Newtons  ';
F_m = input(prompt6);
prompt7 = 'enter deflection that coresponds the ultimate tensile force in mm  ';
u_m = input(prompt7);

B = (E*h^3)/(12*(1-miu^2)); %% in N*mm
r_1 = 1.25; %% in mm
%% PARABOLIC DISTRIBUTION
p_max = (F*2)/(pi*r_1^2); %% in MPa
%% Integration constants FOR FIXED SUPPORT
X=[1 -1 (2*(1-miu))/(r_1^2*(1+miu));-1 1 2/r_1^2;0 r_2^2/2 1];
b = [p_max*r_1^2*log(r_1)/(4*B)-(p_max*r_1^2*(3+miu))/((1+miu)*8*B)+((5+miu)*r_1^2*p_max)/(48*B*(1+miu))-(p_max*r_1^2*(miu-1))/((1+miu)*8*B);
    (11*p_max*r_1^2)/(48*B)-(p_max*r_1^2*log(r_1))/(4*B);
    p_max*r_1^2*r_2^2/(16*B)-p_max*r_1^2*r_2^2*log(r_2)/(8*B)];
C = X\b;
C_1fxd = C(1,1);
C_2fxd = 0;
C_3fxd = C(2,1);
C_4fxd = C(3,1);

%% Moments in first interval
m_r1_0=(p_max*0^4*(5+miu))/(96*r_1^2)+(p_max*0^2*(-3-miu))/16 +(C_1fxd*B*(-1-miu))/2;
m_t1_0=(p_max*0^4*(1+5*miu))/(96*r_1^2 )+(p_max*0^2*(-1-3*miu))/16 +(C_1fxd*B*(-1-miu))/2;

m_r1=(p_max*r_1^4*(5+miu))/(96*r_1^2)+(p_max*r_1^2*(-3-miu))/16 +(C_1fxd*B*(-1-miu))/2;
m_t1=(p_max*r_1^4*(1+5*miu))/(96*r_1^2 )+(p_max*r_1^2*(-1-3*miu))/16+(C_1fxd*B*(-1-miu))/2;

%% Second interval
m_r2 = (p_max*r_1^2*(miu-1))/16+(p_max*r_1^2*log(r_2)*(-1-miu))/8+(C_4fxd*B*(1-miu))/r_1^2+(C_3fxd*B*(-miu-1))/2;
m_t2 = (p_max*r_1^2*(1-miu))/16+(p_max*r_1^2*log(r_2)*(-1-miu))/8+(C_4fxd*B*(miu-1))/r_1^2+(C_3fxd*B*(-miu-1))/2;

%% Maximum moments
mradialfxdpara = [m_r1_0;m_r1;abs(m_r2)];
m_rfxdPARA = max (mradialfxdpara);

mtangentfxdpara = [m_t1_0;m_t1;abs(m_t2)];
m_tfxdPARA = max (mtangentfxdpara);

%% Maximum stress
Sigma_rPARAfxd=m_rfxdPARA*6/(h^2);
Sigma_tPARAfxd=m_tfxdPARA*6/(h^2);
SigmaPARA = [Sigma_rPARAfxd,Sigma_tPARAfxd,abs(Sigma_rPARAfxd-Sigma_tPARAfxd)];
Sigma_yPARAfxd = max (SigmaPARA);

%% END OF PART 1

%% Integration constants FOR PINNED SUPPORT
X2=[1 -1 (2*(1-miu))/(r_1^2*(1+miu));-1 1 2/r_1^2;0 -((1+miu)*r_2^2)/(2*(1-miu)) 1];
b2 =[p_max*r_1^2*log(r_1)/(4*B)-(p_max*r_1^2*(3+miu))/((1+miu)*8*B)+((5+miu)*r_1^2*p_max)/(48*B*(1+miu))-(p_max*r_1^2*(miu-1))/((1+miu)*8*B);
    (11*p_max*r_1^2)/(48*B)-(p_max*r_1^2*log(r_1))/(4*B);
    p_max*r_1^2*r_2^2*(1+miu)*log(r_2)/(8*B*(1-miu))+p_max*r_1^2*r_2^2/(16*B)];
C2 = X2\b2;
C_1pin = C2(1,1);
C_2pin = 0;
C_3pin = C2(2,1);
C_4pin = C2(3,1);

%% Moments in first interval
m_r1pin_0=(p_max*0^4*(5+miu))/(96*r_1^2)+(p_max*0^2*(-3-miu))/16 +(C_1pin*B*(-1-miu))/2;
m_t1pin_0=(p_max*0^4*(1+5*miu))/(96*r_1^2 )+(p_max*0^2*(-1-3*miu))/16 +(C_1pin*B*(-1-miu))/2;

m_r1pin=(p_max*r_1^4*(5+miu))/(96*r_1^2)+(p_max*r_1^2*(-3-miu))/16 +(C_2pin*B*(1-miu))/r_1^2 +(C_1pin*B*(-1-miu))/2;
m_t1pin=(p_max*r_1^4*(1+5*miu))/(96*r_1^2 )+(p_max*r_1^2*(-1-3*miu))/16+(C_2pin*B*(miu-1))/r_1^2 +(C_1pin*B*(-1-miu))/2;
%% Second interval
m_r2pin = (p_max*r_1^2*(miu-1))/16+(p_max*r_1^2*log(r_2)*(-1-miu))/8+(C_4pin*B*(1-miu))/r_2^2+(C_3pin*B*(-miu-1))/2;
m_t2pin = (p_max*r_1^2*(1-miu))/16+(p_max*r_1^2*log(r_2)*(-1-miu))/8+(C_4pin*B*(miu-1))/r_2^2+(C_3pin*B*(-miu-1))/2;

%% Maximum moments
mradialpinpara = [m_r1pin_0;m_r1pin;abs(m_r2pin)];
m_rpinPARA = max (mradialpinpara);

mtangentpinpara = [m_t1pin_0;m_t1pin;abs(m_t2pin)];
m_tpinPARA = max (mtangentpinpara);

%% Maximum stresses
Sigma_rPARApin=m_rpinPARA*6/(h^2);
Sigma_tPARApin=m_tpinPARA*6/(h^2);
SigmaPARApin = [Sigma_rPARApin,Sigma_tPARApin,abs(Sigma_rPARApin-Sigma_tPARApin)];
Sigma_yPARApin = max (SigmaPARApin);

%% END OF PART 2

%% LINEAR DISTRIBUTION 
pmax2 = F/(pi*r_1^2-2*pi*r_1^3/(3*r_2));
A = (-pmax2*r_1^3)/(3*r_2*B)+(pmax2*r_1^2)/(2*B);
%% Intergration constants FOR FIXED SUPPORT 
Y = [1 -1 (1-miu)*2/((1+miu)*r_1^2); -1 1 2/r_1^2; 0 r_2^2/2 1];
b3 = [((4+miu)*2*pmax2*r_1^3)/(45*B*r_2*(1+miu))-(pmax2*r_1^2*(3+miu))/((1+miu)*8*B)+A*log(r_1)-A*(miu-1)/(2*(1+miu));
    (pmax2*r_1^2)/(8*B)-(2*pmax2*r_1^3)/(45*B*r_2)+A/2-A*log(r_1);
    A*r_2^2/4-(A*log(r_2)*r_2^2)/2];            
C3 = Y\b3;
C_1fxd2 = C3(1,1);
C_2fxd2 = 0;
C_3fxd2 = C3(2,1);
C_4fxd2 = C3(3,1);

%% Moments in first interval
m_r1_20 = ((4+miu)*pmax2*0)/(45*r_2)-(pmax2*(3+miu)*0)/16-C_1fxd2*B*(1+miu)/2; 
m_t1_20 = ((1+4*miu)*pmax2*0)/(45*r_2)-(pmax2*(1+3*miu)*0)/16-C_1fxd2*B*(1+miu)/2;

m_r1_2 = ((4+miu)*pmax2*r_1^3)/(45*r_2)-(pmax2*(3+miu)*r_1^2)/16-C_1fxd2*B*(1+miu)/2;  
m_t1_2 = ((1+4*miu)*pmax2*r_1^3)/(45*r_2)-(pmax2*(1+3*miu)*r_1^2)/16-C_1fxd2*B*(1+miu)/2;
%% Second interval
m_r2_2 = -((1+miu)*B*C_3fxd2)/2+(B*A*(miu-1))/4-((1+miu)*A*B*log(r_2))/2+((1-miu)*C_4fxd2*B)/r_2^2;
m_t2_2 = -((1+miu)*B*C_3fxd2)/2+(B*A*(1-miu))/4-((1+miu)*A*B*log(r_2))/2+((miu-1)*C_4fxd2*B)/r_2^2;

%% Maximum moments
mradialfxd2 = [m_r1_20;m_r1_2;abs(m_r2_2)];
m_rmaxfxd2 = max (mradialfxd2);

mtangentfxd2 = [m_t1_20;m_t1_2;abs(m_t2_2)];
m_tmaxfxd2 = max (mtangentfxd2);

%% Maximum stresses
Sigma_rLINEfxd=m_rmaxfxd2*6/(h^2);
Sigma_tLINEfxd=m_tmaxfxd2*6/(h^2);
SigmaLINE = [Sigma_rLINEfxd,Sigma_tLINEfxd,abs(Sigma_rLINEfxd-Sigma_tLINEfxd)];
Sigma_yLINEfxd = max (SigmaLINE);

%% END OF PART 3

%% Integration constants for PINNED SUPPORT
Y2 = [1 -1 (2*(1-miu))/(r_1^2*(1+miu)); -1 1 2/r_1^2; 0 -((1+miu)*r_2^2)/(2*(1-miu)) 1];
b4 = [((4+miu)*2*pmax2*r_1^3)/(45*B*r_2*(1+miu))-(pmax2*r_1^2*(3+miu))/((1+miu)*8*B)+A*log(r_1)-A*(miu-1)/(2*(1+miu));
    (pmax2*r_1^2)/(8*B)-(2*pmax2*r_1^3)/(45*B*r_2)+A/2-A*log(r_1);
    +A*r_2^2/4+((1+miu)*A*log(r_2)*r_2^2)/(2*(1-miu))];
C4 = Y2\b4;
C_1pin2 = C4(1,1);
C_2pin2 = 0;
C_3pin2 = C4(2,1);
C_4pin2 = C4(3,1);

%% Moments in first interval
m_r1pin2_0 = ((4+miu)*pmax2*0)/(45*r_2)-(pmax2*(3+miu)*0)/16-C_1pin2*B*(1+miu)/2; 
m_t1pin2_0 = ((1+4*miu)*pmax2*0)/(45*r_2)-(pmax2*(1+3*miu)*0)/16-C_1pin2*B*(1+miu)/2;

m_r1pin2 = ((4+miu)*pmax2*r_1^3)/(45*r_2)-(pmax2*(3+miu)*r_1^2)/16-C_1pin2*B*(1+miu)/2;  
m_t1pin2 = ((1+4*miu)*pmax2*r_1^3)/(45*r_2)-(pmax2*(1+3*miu)*r_1^2)/16-C_1pin2*B*(1+miu)/2;
%% Second interval
m_r2pin2 = -((1+miu)*B*C_3pin2)/2+(B*A*(miu-1))/4-((1+miu)*A*B*log(r_2))/2+((1-miu)*C_4pin2*B)/r_2^2;
m_t2pin2 = -((1+miu)*B*C_3pin2)/2+(B*A*(1-miu))/4-((1+miu)*A*B*log(r_2))/2+((miu-1)*C_4pin2*B)/r_2^2;

%% Maximum moments
mradialpin2 = [m_r1pin2_0;m_r1pin2;abs(m_r2pin2)];
m_rmaxpin2 = max (mradialpin2);
mtangentpin2 = [m_t1pin2_0;m_t1pin2;abs(m_t2pin2)];
m_tmaxpin2 = max (mtangentpin2);

%% Maximum stress
Sigma_rLINEpin=m_rmaxpin2*6/(h^2);
Sigma_tLINEpin=m_tmaxpin2*6/(h^2);
SigmaLINEpin = [Sigma_rLINEpin,Sigma_tLINEpin,abs(Sigma_rLINEpin-Sigma_tLINEpin)];
Sigma_yLINEpin = max (SigmaLINEpin);

%% END OF PART 4

%% LONE FORCE MODEL
m_rfxdforce = (F*(miu-1))/(8*pi)-((1+miu)*F*log(r_1))/(4*pi)-((F)/(B*4*pi)-(F*log(r_2))/(2*pi*B))*((1+miu)*B)/2;
m_tfxdforce = (F*(1-miu))/(8*pi)-((1+miu)*F*log(r_1))/(4*pi)-((F)/(B*4*pi)-(F*log(r_2))/(2*pi*B))*((1+miu)*B)/2;

m_rpinforce = (F*(miu-1))/(8*pi)-((1+miu)*F*log(r_1))/(4*pi)-(((miu-1)*F)/((1+miu)*B*4*pi)-(F*log(r_2))/(2*pi*B))*((1+miu)*B)/2;
m_tpinforce = (F*(1-miu))/(8*pi)-((1+miu)*F*log(r_1))/(4*pi)-(((miu-1)*F)/((1+miu)*B*4*pi)-(F*log(r_2))/(2*pi*B))*((1+miu)*B)/2;

%% FIXED SUPPORT
Sigma_rFORCEfxd=abs(m_rfxdforce)*6/(h^2);
Sigma_tFORCEfxd=abs(m_tfxdforce)*6/(h^2);
Sigma_yFORCEfxd = max (Sigma_rFORCEfxd,Sigma_tFORCEfxd);

%% PINNED SUPPORT
Sigma_rFORCEpin=abs(m_rpinforce)*6/(h^2);
Sigma_tFORCEpin=abs(m_tpinforce)*6/(h^2);
Sigma_yFORCEpin = max (Sigma_rFORCEpin,Sigma_tFORCEpin);

%% END OF PART 5

%% CONSTANT PRESSURE MODEL 
pmax3 = F/(pi*r_1^2);
%% Integration constants for FIXED SUPPORT
Z = [1 -1 2*(1-miu)/(r_1^2*(1+miu)); -1 1 2/r_1^2; 0 r_2^2/2 1];
b5 = [-((3+miu)*pmax3*r_1^2)/((1+miu)*8*B)-(pmax3*r_1^2*(miu-1))/(4*B*(1+miu))+pmax3*r_1^2*log(r_1)/(2*B);
    (pmax3*r_1^2*log(r_2))/(2*B)-(3*pmax3*r_1^2)/(7*B);
    (pmax3*r_1^2*r_2^2)/(8*B)-(pmax3*r_1^2*r_2^2*log(r_2))/(4*B)];                    
C5 = Z\b5;
C_1fxdkonst = C5(1,1);
C_2fxdkonst= 0;
C_3fxdkonst = C5(2,1);
C_4fxdkonst = C5(3,1);

%% Moments in first interval
m_r1fxdkonst = -((3+miu)*pmax3*0)/16 - (C_1fxdkonst*B*(1+miu))/2;
m_t1fxdkonst = -((1+3*miu)*pmax3*0)/16 - (C_1fxdkonst*B*(1+miu))/2;

m_r1fxdkonst2 = -((3+miu)*pmax3*r_1^2)/16 - (C_1fxdkonst*B*(1+miu))/2;
m_t1fxdkonst2 = -((1+3*miu)*pmax3*r_1^2)/16 - (C_1fxdkonst*B*(1+miu))/2;
%% Second interval
m_r2fxdkonst = (-C_3fxdkonst*B*(1+miu))/2 + (pmax3*r_1^2*(miu-1))/8-(pmax3*r_1^2*(1+miu)*log(r_2))/4+(C_4fxdkonst*B*(1-miu))/r_2^2;
m_t2fxdkonst = (-C_3fxdkonst*B*(1+miu))/2 + (pmax3*r_1^2*(1-miu))/8-(pmax3*r_1^2*(1+miu)*log(r_2))/4+(C_4fxdkonst*B*(miu-1))/r_2^2;

%% Maximum moments
mradialfxdkonst = [m_r1fxdkonst;m_r1fxdkonst2;abs(m_r2fxdkonst)];
m_rfxdkonst = max (mradialfxdkonst);

mtangentfxdkonst = [m_t1fxdkonst;m_t1fxdkonst2;abs(m_t2fxdkonst)];
m_tfxdkonst = max (mtangentfxdkonst);

%% Maximum stress
Sigma_rCONSTfxd=m_rfxdkonst*6/(h^2);
Sigma_tCONSTfxd=m_tfxdkonst*6/(h^2);
SigmaCONST = [Sigma_rCONSTfxd,Sigma_tCONSTfxd,abs(Sigma_rCONSTfxd-Sigma_tCONSTfxd)];
Sigma_yCONSTfxd = max (SigmaCONST);

%% END OF PART 6

%% Integration constants for PINNED SUPPORT
Z2 = [1 -1 2*(1-miu)/(r_1^2*(1+miu)); -1 1 2/r_1^2; 0 -((1+miu)*r_2^2)/(2*(1-miu)) 1];
b6 = [-((3+miu)*pmax3*r_1^2)/((1+miu)*8*B)-(pmax3*r_1^2*(miu-1))/(4*B*(1+miu))+pmax3*r_1^2*log(r_1)/(2*B);
    (pmax3*r_1^2*log(r_2))/(2*B)-(3*pmax3*r_1^2)/(7*B);
    (pmax3*r_1^2*r_2^2)/(8*B)+(pmax3*r_1^2*r_2^2*(1+miu)*log(r_2))/(4*B*(1-miu))];
C6 = Z2\b6;
C_1pinkonst = C6(1,1);
C_2pinkonst= 0;
C_3pinkonst = C6(2,1);
C_4pinkonst = C6(3,1);

%% Moments in first interval
m_r1pinkonst = -((3+miu)*pmax3*0)/16 - (C_1pinkonst*B*(1+miu))/2;
m_t1pinkonst = -((1+3*miu)*pmax3*0)/16 - (C_1pinkonst*B*(1+miu))/2;

m_r1pinkonst2 = -((3+miu)*pmax3*r_1^2)/16 - (C_1pinkonst*B*(1+miu))/2;
m_t1pinkonst2 = -((1+3*miu)*pmax3*r_1^2)/16 - (C_1pinkonst*B*(1+miu))/2;
%% Second interval
m_r2pinkonst = (-C_3pinkonst*B*(1+miu))/2 + (pmax3*r_1^2*(miu-1))/8-(pmax3*r_1^2*(1+miu)*log(r_2))/4+(C_4pinkonst*B*(1-miu))/r_2^2;
m_t2pinkonst = (-C_3pinkonst*B*(1+miu))/2 + (pmax3*r_1^2*(1-miu))/8-(pmax3*r_1^2*(1+miu)*log(r_2))/4+(C_4pinkonst*B*(miu-1))/r_2^2;

%% Maximum moments
mradialpinkonst = [m_r1pinkonst;m_r1pinkonst2;abs(m_r2pinkonst)];
m_rpinkonst = max (mradialpinkonst);

mtangentpinkonst = [m_t1pinkonst;m_t1pinkonst2;abs(m_t2pinkonst)];
m_tpinkonst = max (mtangentpinkonst);

%% Maximum stress
Sigma_rCONSTpin=m_rpinkonst*6/(h^2);
Sigma_tCONSTpin=m_tpinkonst*6/(h^2);
SigmaCONSTpin = [Sigma_rCONSTpin,Sigma_tCONSTpin,abs(Sigma_rCONSTpin-Sigma_tCONSTpin)];
Sigma_yCONSTpin = max (SigmaCONSTpin);

%% END OF PART 7

%% Emirical equations
%% Mao
sigmamao_k = 0.36*(F/h^2);
sigmamao_m = 0.13*(F_m/h^2)+320;
%% Ruan
sigmaruan_k = 0.413*(F/h^2 );
%% Finarelli
sigmafinarelli_k = 0.45*(F/h^2 );
%%Cuesta a Alegre
sigmacuesta_k = 0.4329*(F/h^2 );
%% Guan and Wang
sigmaguan_k = 0.4847*(F/h^2)+21.359;
sigmawang_m = 0.0666*(F_m/h^2)+146.03;
%% Song and his team
sigmasong_k = 0.23944*(F/h^2)+55.26;
sigmasong_m = 0.07464*(F_m/h^2)+92.54;
%% Norris and Parker
sigmachuck_k = 0.457*(F/h^2);
sigmachuck_m = 0.0846*(F_m/h^2); 
%% Garcia
sigmagarcia_k = 0.346*(F/h^2);
sigmagarcia_m = 0.84*(F/h^2);
sigmagarcia2_m = 0.277*(F_m/(u_m*h));
%% Purmensky, Matocha
sigmamatocha_m = 0.35*(F_m/(u_m*h))+23;
%% Matocha, Hurst
sigmahurst_m = 0.444*(F_m/(u_m*h))+86.8;

%% OUTPUTS of Empirical relations
fprintf('Below are the yield stresses according to specific empirical equations:\n\n')
fprintf('Mao and Takahashis equation:  %.0f MPa\n', sigmamao_k)
fprintf('Ruans equation:               %.0f MPa\n', sigmaruan_k)
fprintf('Finarellis equation:          %.0f MPa\n', sigmafinarelli_k)
fprintf('Cuesta and Alegres equation:  %.0f MPa\n', sigmacuesta_k)
fprintf('Guan and Wangs equation:      %.0f MPa\n', sigmaguan_k)
fprintf('Song and his teams equation:  %.0f MPa\n', sigmasong_k)
fprintf('Norris and Parkers equation:  %.0f MPa\n', sigmachuck_k)
fprintf('Garcias equation:             %.0f MPa\n\n', sigmagarcia_k)

fprintf('Below are the ultimate tensile stresses according to specific empirical equations:\n\n')
fprintf('Mao and Takahashis equation:     %.0f MPa\n', sigmamao_m)
fprintf('Guan and Wangs equation:         %.0f MPa\n', sigmawang_m)
fprintf('Song and his teams equation:     %.0f MPa\n', sigmasong_m)
fprintf('Norris and Parkers equation:     %.0f MPa\n', sigmachuck_m)
fprintf('Garcias equation:                %.0f MPa\n', sigmagarcia_m)
fprintf('Garcias modified equatin:        %.0f MPa\n', sigmagarcia2_m)
fprintf('Purmensky and Matochas equation: %.0f MPa\n', sigmamatocha_m)
fprintf('Matocha and Hursts equation:     %.0f MPa\n\n', sigmahurst_m)

%% OUTPUTS of computed models
fprintf('Below are the yield stresses according to analytical solution based on Kirchhoff theory:\n\n')
fprintf ('Lone force model yield stress in fixed support:   		              %.0f MPa\n', Sigma_yFORCEfxd)
fprintf ('Lone force model yield stress in pinned support: 		              %.0f MPa\n', Sigma_yFORCEpin)
fprintf ('Constant pressure distribution model yield stress in fixed support:   %.0f MPa\n', Sigma_yCONSTfxd)
fprintf ('Constant pressure distribution model yield stress in pinned support:  %.0f MPa\n', Sigma_yCONSTpin)
fprintf ('Parabolic pressure distribution model yield stress in fixed support:  %.0f MPa\n', Sigma_yPARAfxd)
fprintf ('Parabolic pressure distribution model yield stress in pinned support: %.0f MPa\n', Sigma_yPARApin)
fprintf ('Linear pressure distribution model yield stress in fixed support:     %.0f MPa\n', Sigma_yLINEfxd)
fprintf ('Linear pressure distribution model yield stress in pinned support:    %.0f MPa\n', Sigma_yLINEpin)
